package com.jjkj.flow.domain;

import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableName;
import com.fasterxml.jackson.annotation.JsonFormat;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;

import java.util.Date;

/**
 * 车辆流水
 * 对象 data_vehicle_flow
 *
 * @author ruoyi
 * @date 2024-01-19
 */
@Data
@AllArgsConstructor
@NoArgsConstructor
@TableName("data_vehicle_flow")
public class DataVehicleFlow {
    private static final long serialVersionUID = 1L;

    /**
     * id
     */
    private String id;

    /**
     * 检验流水号
     */
    private String lsh;

    /**
     * 检验机构编号
     */
    private String jyjgbh;

    /**
     * 检验类别
     */
    private String jylb;

    /**
     * 号牌种类
     */
    private String hpzl;

    /**
     * 号牌号码
     */
    private String hphm;

    /**
     * 检验次数
     */
    private Integer jycs;
    private String jcxdh;
    /**
     * 车辆识别代号
     */
    private String clsbdh;

    /**
     * 流水状态（看字典表）
     */
    private String lszt;

    /**
     * 联网查询判定 0_未检 1_已检
     */
    private String nqpd;

    /**
     * 唯一性判定 0_未检 1_已检
     */
    private String ucpd;

    /**
     * 外检判定 0_未检 1_已检
     */
    private String wjpd;

    /**
     * 底盘动态判定 0_未检 1_已检
     */
    private String dpdtpd;

    /**
     * 底盘检验判定 0_未检 1_已检
     */
    private String dpjypd;

    /**
     * 开始时间
     */
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private Date kssj;

    /**
     * 结束时间
     */
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private Date jssj;

    /**
     * 路试判定  0_未检 1_已检
     */
    private String lspd;

    /**
     * 整车判定  0_未检 1_已检
     */
    private String zcpd;
    /**
     * 下载状态  0_未下载 1_已下载
     */
    private String flag;

    /**
     * 创建时间
     */
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private Date createtime;
    @TableField(value = "checkcode")
    private int checkCode;
    private String checksum;


}
