package com.jjkj.quarz.controller;

import cn.hutool.core.util.StrUtil;
import com.github.pagehelper.PageHelper;

import com.github.pagehelper.PageInfo;
import com.jjkj.quarz.config.CronTaskRegistrar;


import com.jjkj.quarz.domain.TaskScheduleEntity;
import com.jjkj.quarz.task.TaskScheduleService;
import com.jjkj.quarz.thread.ThreadSequenceService;
import com.jjkj.quarz.runnable.SchedulingRunnable;
import com.jjkj.util.AjaxResult;
import com.jjkj.util.Page;
import com.jjkj.video.service.IDataResultVideoService;
import org.apache.log4j.Logger;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.servlet.ModelAndView;

import javax.servlet.http.HttpServletRequest;
import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

@RestController
@RequestMapping("/taskSchedule")

public class TaskScheduleController {
    @Autowired
    private ThreadSequenceService threadSequenceService;
    @Autowired
    private CronTaskRegistrar cronTaskRegistrar;
    @Autowired
    private TaskScheduleService taskScheduleService;

    private Logger logger = Logger.getLogger(TaskScheduleController.class);

    /**
     * 进入定时任务页面
     *
     * @param
     * @return
     */
    @RequestMapping(value = "taskList")
    public ModelAndView taskJob(Page<TaskScheduleEntity> page) {
        Map<String, Object> resultMap = new HashMap<>();
        //查询所有任务列表
        if (page.getPageNum() == null || page.getPageNum() < 1) {
            page.setPageNum(1);
        }
        if (page.getPages() == null || page.getPages() < 1) {
            page.setPageSize(5);
        }
        // 设定分页条件
        PageHelper.startPage(page.getPageNum(), page.getPageSize());
        List<TaskScheduleEntity> settingList = this.taskScheduleService.findALLSchedule();
        if (settingList != null && settingList.size() > 0) {
            PageInfo<TaskScheduleEntity> resultPage = new PageInfo<TaskScheduleEntity>(settingList);
            resultMap.put("page", resultPage);


        }
        return new ModelAndView("/views/task/taskList", resultMap);
    }

    @Autowired
    private IDataResultVideoService iDataResultVideoService;

    @RequestMapping("countJcsp")
    public AjaxResult countJcsp() {

        return iDataResultVideoService.countJcsp();
    }
    /**
     * 添加定时任务
     *
     * @param sysJob
     * @return
     */
    @PostMapping("add")
    public boolean add(@RequestBody TaskScheduleEntity sysJob) {
      /*  sysJob.setCreateTime(new Date());
        sysJob.setUpdateTime(new Date());

        boolean insert = sysJob.insert();
        if (!insert) {
            return false;
        } else {
            if (sysJob.getJobStatus().equals(1)) {// 添加成功,并且状态是1，直接放入任务器
                SchedulingRunnable task = new SchedulingRunnable(sysJob.getBeanName(), sysJob.getMethodName(), sysJob.getMethodParams());
                cronTaskRegistrar.addCronTask(task, sysJob.getCronExpression());
            }
        }
        return insert;*/
        return true;
    }

    /**
     * 编辑任务页面
     *
     * @param request
     * @param jobId
     * @return
     */
    @RequestMapping(value = "editTask/{jobId}")
    @ResponseBody
    public ModelAndView editTask(HttpServletRequest request, @PathVariable("jobId") String jobId) {
        Map<String, Object> resultMap = new HashMap<>();
        if (StrUtil.isNotEmpty(jobId)) {
            // 查询修改前任务
            TaskScheduleEntity existedSysJob = this.taskScheduleService.findTaskJobById(jobId);
            if (existedSysJob != null) {
                resultMap.put("day", existedSysJob.getMethodParams().split(",")[0]);
                resultMap.put("number", existedSysJob.getMethodParams().split(",")[1]);
                resultMap.put("taskSchedule", existedSysJob);
            }
        }


        return new ModelAndView("/views/task/editTask", resultMap);
    }


    /**
     * 修改定时任务
     *
     * @param sysJob
     * @return
     */
    @PostMapping(value = "update")
    public Integer update(TaskScheduleEntity sysJob, String day, String number) {
        Integer update = 0;
        // 查询修改前任务
        TaskScheduleEntity existedSysJob = this.taskScheduleService.findTaskJobById(sysJob.getJobId());
        if (existedSysJob != null && StrUtil.isNotEmpty(day) && StrUtil.isNotEmpty(number)) {
            existedSysJob.setCreateTime(new Date());
            existedSysJob.setUpdateTime(new Date());
            existedSysJob.setJobStatus(sysJob.getJobStatus());
            existedSysJob.setCronExpression(sysJob.getCronExpression());
            existedSysJob.setMethodParams(day + "," + number);
            existedSysJob.setRemark(sysJob.getRemark());
            // 修改任务
            update = this.taskScheduleService.updateTaskJob(existedSysJob);
            if (update > 0) {
                // 修改成功,则先删除任务器中的任务,并重新添加
                SchedulingRunnable task1 = new SchedulingRunnable(existedSysJob.getBeanName(), existedSysJob.getMethodName(), existedSysJob.getMethodParams());
//                SchedulingRunnable task1 = new SchedulingRunnable(existedSysJob.getBeanName(), existedSysJob.getMethodName());
                cronTaskRegistrar.removeCronTask(task1);
                if (sysJob.getJobStatus().equals(1)) {// 如果修改后的任务状态是1就加入任务器
                    SchedulingRunnable task = new SchedulingRunnable(existedSysJob.getBeanName(), existedSysJob.getMethodName(), existedSysJob.getMethodParams());
//                    SchedulingRunnable task = new SchedulingRunnable(existedSysJob.getBeanName(), existedSysJob.getMethodName());
                    cronTaskRegistrar.addCronTask(task, existedSysJob.getCronExpression());
                    logger.info(existedSysJob.getRemark() + ":任务添加成功");
                }

            }
        }
        return update;
    }

    /**
     * 删除任务
     *
     * @param jobId
     * @return
     */
    @PostMapping("delete/{jobId}")
    public Integer deleleTask(@PathVariable("jobId") String jobId) {
        // 先查询要删除的任务信息
        Integer delete = 0;
        TaskScheduleEntity existedSysJob = this.taskScheduleService.findTaskJobById(jobId);
        if (existedSysJob != null) {
            delete = this.taskScheduleService.deleteTask(jobId);

            if (delete > 0) {
                SchedulingRunnable task = new SchedulingRunnable(existedSysJob.getBeanName(), existedSysJob.getMethodName(), existedSysJob.getMethodParams());
//                SchedulingRunnable task = new SchedulingRunnable(existedSysJob.getBeanName(), existedSysJob.getMethodName());
                cronTaskRegistrar.removeCronTask(task);
                logger.info(existedSysJob.getRemark() + ":任务删除成功");

            }
        }
        return delete;
    }

    // 停止/启动任务
    @PostMapping("changesStatus/{jobId}/{stop}")
    public boolean changesStatus(@PathVariable("jobId") String jobId, @PathVariable("stop") Integer stop) {
        // 修改任务状态
        TaskScheduleEntity taskSchedule = new TaskScheduleEntity();
        taskSchedule.setJobId(jobId);
        taskSchedule.setJobStatus(stop);
        Integer job_id = this.taskScheduleService.updateTaskJob(taskSchedule);
        if (StrUtil.isEmpty(jobId)) {
            return false;
        }

        // 查询修改后的任务信息
        TaskScheduleEntity existedSysJob = this.taskScheduleService.findTaskJobById(jobId);

        // 如果状态是1则添加任务
        if (existedSysJob.getJobStatus().equals(1)) {
            SchedulingRunnable task = new SchedulingRunnable(existedSysJob.getBeanName(), existedSysJob.getMethodName(), existedSysJob.getMethodParams());
//            SchedulingRunnable task = new SchedulingRunnable(existedSysJob.getBeanName(), existedSysJob.getMethodName());
            cronTaskRegistrar.addCronTask(task, existedSysJob.getCronExpression());
            logger.info(existedSysJob.getRemark() + ":任务添加成功");

        } else {
            // 否则清除任务
            SchedulingRunnable task = new SchedulingRunnable(existedSysJob.getBeanName(), existedSysJob.getMethodName(), existedSysJob.getMethodParams());
//            SchedulingRunnable task = new SchedulingRunnable(existedSysJob.getBeanName(), existedSysJob.getMethodName());
            cronTaskRegistrar.removeCronTask(task);
            logger.info(existedSysJob.getRemark() + ":任务删除成功");

        }
        return true;
    }

    /**
     * 手动执行定时任务
     *
     * @param jobId
     * @return
     */
    @PostMapping(value = "manualTask/{jobId}")
    public boolean manualeExecuteTask(@PathVariable("jobId") String jobId) {
        //查询定时任务
        if (StrUtil.isNotEmpty(jobId)) {
            TaskScheduleEntity existedSysJob = this.taskScheduleService.findTaskJobById(jobId);
            if (existedSysJob != null) {
                if (existedSysJob.getMethodName().equals("downloadJcsp")) {
                    try {
                        this.threadSequenceService.downloadJcsp(existedSysJob.getMethodParams());
                    } catch (InterruptedException e) {
                        e.printStackTrace();
                    }
                    return true;
                } else if (existedSysJob.getMethodName().equals("test")) {

                    return true;
                } else {

                    return false;
                }
            }
        }
        return false;
    }
}