package com.jjkj.quarz.runnable;


import com.baomidou.mybatisplus.core.toolkit.CollectionUtils;
import com.jjkj.quarz.config.CronTaskRegistrar;

import com.jjkj.quarz.domain.TaskScheduleEntity;
import com.jjkj.quarz.mapper.TaskScheduleMapper;
import org.apache.log4j.Logger;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.CommandLineRunner;
import org.springframework.stereotype.Service;

import java.util.List;

@Service
public class SysJobRunner implements CommandLineRunner {

    private static final Logger logger = Logger.getLogger(SysJobRunner.class);

    @Autowired
    private CronTaskRegistrar cronTaskRegistrar;
    @Autowired
    private TaskScheduleMapper scheduleSettingMapper;

    @Override
    public void run(String... args) {
        // 初始加载数据库里状态为正常的定时任务
        List<TaskScheduleEntity> jobList = this.scheduleSettingMapper.getScheduleByJobStatus(1);
        if (CollectionUtils.isNotEmpty(jobList)) {
            for (TaskScheduleEntity job : jobList) {
                  SchedulingRunnable shjgTask = new SchedulingRunnable(job.getBeanName(), job.getMethodName(), job.getMethodParams());
//                    SchedulingRunnable shjgTask = new SchedulingRunnable(job.getBeanName(), job.getMethodName());
                cronTaskRegistrar.addCronTask(shjgTask, job.getCronExpression());

            }
            logger.info("定时任务已加载完毕...");

        }
    }
}