package com.jjkj.video.mapper;

import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.jjkj.video.pojo.DataResultVideo;
import org.apache.ibatis.annotations.Mapper;

import java.util.List;

/**
 * 检测视频Mapper接口
 * 
 * @author 南
 * @date 2024-01-22
 */
@Mapper
public interface DataResultVideoMapper extends BaseMapper<DataResultVideo>
{
    /**
     * 查询检测视频
     * 
     * @param id 检测视频主键
     * @return 检测视频
     */
    public DataResultVideo selectDataResultVideoById(String id);

    /**
     * 查询检测视频列表
     * 
     * @param dataResultVideo 检测视频
     * @return 检测视频集合
     */
    public List<DataResultVideo> selectDataResultVideoList(DataResultVideo dataResultVideo);

    /**
     * 新增检测视频
     * 
     * @param dataResultVideo 检测视频
     * @return 结果
     */
    public int insertDataResultVideo(DataResultVideo dataResultVideo);

    /**
     * 修改检测视频
     * 
     * @param dataResultVideo 检测视频
     * @return 结果
     */
    public int updateDataResultVideo(DataResultVideo dataResultVideo);

    /**
     * 删除检测视频
     * 
     * @param id 检测视频主键
     * @return 结果
     */
    public int deleteDataResultVideoById(String id);

    /**
     * 批量删除检测视频
     * 
     * @param ids 需要删除的数据主键集合
     * @return 结果
     */
    public int deleteDataResultVideoByIds(String[] ids);
}
