<%@ page language="java" import="java.util.*" pageEncoding="utf-8" %>
<%@ taglib prefix="c" uri="http://java.sun.com/jstl/core_rt" %>
<%@ taglib prefix="fmt" uri="http://java.sun.com/jstl/fmt_rt" %>
<%@ taglib prefix="fn" uri="http://java.sun.com/jsp/jstl/functions" %>
<%
    String path = request.getContextPath();
    String basePath = request.getScheme() + "://" + request.getServerName() + ":" + request.getServerPort() + path + "/";
%>
<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="utf-8">
    <title>自治区上传结果</title>
    <script src="<%=path %>/js/jquery-1.10.2.min.js" type="text/javascript"></script>
    <script src="<%=path %>/js/bootstrap.min.js" type="text/javascript"></script>
    <script src="<%=path %>/js/bootstrap-paginator.js" type="text/javascript"></script>
    <link href="<%=path %>/css/bootstrap.min.css" rel="stylesheet" type="text/css"/>
    <link href="<%=path %>/css/bootstrap-datetimepicker.min.css" rel="stylesheet" media="screen">
    <link href="<%=path %>/css/bootstrapv3.min.css" rel="stylesheet" type="text/css"/>
    <style type="text/css">
        #rgjytdForm {
            width: 450px;
        }

        #rgjytdForm label {
            width: 80px;
        }

        #rgjytdForm label.error {
            margin-left: 10px;
            width: auto;
            color: red;
            display: inline;
        }
    </style>
</head>
<body style="overflow-y: hidden">
<form id=rgjytdForm>
    <div style="width: 1220px;height:700px;" class="portlet-body">
        <table class="table  table-bordered table-hover table-full-width">
            <thead>
            <tr style="background:#428bca;color:#fff;height: 5px;">
                <th style="text-align: center">接口ID</th>
                <th style="text-align: center">接口说明</th>
                <th style="text-align: center">车辆检测日流水号</th>
                <th style="text-align: center">检测次数</th>
                <th style="text-align: center">号牌号码</th>
                <th style="text-align: center">号牌种类</th>
                <th style="text-align: center">上传状态</th>
                <th style="text-align: center">操作</th>
            </tr>
            </thead>
            <tbody id="oneCheck">
            <c:if test="${dataList.size() != 0}">
                <c:forEach items="${dataList}" var="scjg">
                    <tr>
                        <td>${scjg.jkid}</td>
                        <td>
                            <c:if test="${scjg.jkid.equals('19C21')}">
                                车辆基本信息
                            </c:if>
                            <c:if test="${scjg.jkid.equals('19C70')}">
                                上传外检信息
                            </c:if>
                            <c:if test="${scjg.jkid.equals('19C71')}">
                                上传OBD信息
                            </c:if>
                            <c:if test="${scjg.jkid.equals('19C09')}">
                                双怠速过程数据
                            </c:if>
                            <c:if test="${scjg.jkid.equals('19C07')}">
                                稳态工况过程数据
                            </c:if>
                            <c:if test="${scjg.jkid.equals('19C14')}">
                                加载减速过程数据
                            </c:if>
                            <c:if test="${scjg.jkid.equals('19C29')}">
                                不透光自由加速过程数据
                            </c:if>
                            <c:if test="${scjg.jkid.equals('19C36')}">
                                上传OBD过程数据
                            </c:if>
                            <c:if test="${scjg.jkid.equals('19S03')}">
                                上传检测过程抓拍图片
                            </c:if>
                            <c:if test="${scjg.jkid.equals('19C10')}">
                                双怠速检测结果数据
                            </c:if>
                            <c:if test="${scjg.jkid.equals('19C08')}">
                                稳态工况检测结果数据
                            </c:if>
                            <c:if test="${scjg.jkid.equals('19C15')}">
                                加载减速检测结果数据
                            </c:if>
                            <c:if test="${scjg.jkid.equals('19C16')}">
                                自由加速不透光检测结果
                            </c:if>
                        </td>
                        <td>${scjg.cljcrlsh}</td>
                        <td>${scjg.jccs}</td>
                        <td>${scjg.hphm}</td>
                        <td>${scjg.hpzl}</td>
                        <td id="jcjgSczt${scjg.jkid}">
                            <c:if test="${scjg.sczt.equals('0')}">
                                等待上传
                            </c:if>
                            <c:if test="${scjg.sczt.equals('1')}">
                                上传成功
                            </c:if>
                            <c:if test="${scjg.sczt.equals('2')}">
                                <p style="color:red;">上传失败</p>
                            </c:if>
                        </td>
                        <td style="text-align: center">
                            <a class="btn btn-success btn-sm">
                                <span onclick="upload('${scjg.jkid}','${scjg.cljcrlsh}','${scjg.jccs}','${scjg.hphm}','${scjg.hpzl}','${scjg.sczt}','${scjg.jyjgbh}')">上传</span>
                            </a>
                        </td>
                    </tr>
                </c:forEach>
            </c:if>
            </tbody>
        </table>
    </div>
    <div style="position:absolute;right:0;bottom:0;">
        <input type="button" value="关闭" class="btn btn-success btn-md" onclick="closeForm()"/>
    </div>
</form>
</body>
<script type="text/javascript">

    function closeForm() {
        parent.closeSecModal();
    }

    function upload(jkid, cljcrlsh, jccs, hphm, hpzl, sczt, jyjgbh) {
        if (jkid == "" || jkid == undefined) {
            alert("请选择你要补传的车辆信息")
            return;
        }
        if ((sczt != "" || sczt != undefined) && sczt == "1") {
            alert("该接口已上传，请勿重复上传！")
            return;
        }

        $.ajax({
            url: '<%=path %>/uploadController/uploadRegion',
            type: 'post',
            data: {
                jyjgbh: jyjgbh,
                cljcrlsh: cljcrlsh,
                jkid: jkid,
                hphm: hphm,
                hpzl: hpzl,
                jccs: jccs,
            },
            success: function (data) {
                var sczt = "";
                var scid = "#jcjgSczt" + jkid;
                alert(data.msg);
                if (data.code == '1') {
                    sczt = "上传成功";
                } else {
                    sczt = "<p style='color:red;'>上传失败</p>";
                }
                $(scid).html(sczt);
            },
            error: function () {
            }
        })

    }
</script>
</body>
</html>
